local frame = CreateFrame("Frame", "dampener", UIParent, "WorldStateAlwaysUpTemplate")
frame:SetScript("OnEvent", function(self, event, ...) self[event](...) end)
frame:RegisterEvent("PLAYER_ENTERING_WORLD")

local dampening
local dampeningtext = GetSpellInfo(110310)
local UnitDebuff = UnitDebuff


function frame.UNIT_AURA(unit)
	local _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, percentage = UnitDebuff(unit, dampeningtext)
	if percentage then
		if not dampening then -- only do this stuff when the buff appears the first time	
			frame:SetPoint("TOP", _G["AlwaysUpFrame"..NUM_ALWAYS_UP_UI_FRAMES], "BOTTOM")
			frame:Show()
		end
		if dampening ~= percentage then
			dampening = percentage
			dampenerText:SetText(dampeningtext..": "..dampening.."%")
		end
	end
end

function frame.PLAYER_ENTERING_WORLD()
	local _, instanceType = IsInInstance()
	if instanceType == "arena" then
		dampening = false
		frame:RegisterUnitEvent("UNIT_AURA", "player")
	else
		frame:UnregisterEvent("UNIT_AURA")
	end
	if frame:IsShown() then
		frame:Hide()
	end
end